/*
** EPITECH PROJECT, 2019
** IndieStudio
** File description:
** InputConvertor
*/

#include"InputConvertor.hpp"
#include "GraphicalException.hpp"

InputConvertor::InputConvertor()
{
	keys["cancel"] = irr::KEY_CANCEL;
	keys["back"] = irr::KEY_BACK;
	keys["tab"] = irr::KEY_TAB;
	keys["clear"] = irr::KEY_CLEAR;
	keys["return"] = irr::KEY_RETURN;
	keys["shift"] = irr::KEY_SHIFT;
	keys["shift"] = irr::KEY_CONTROL;
	keys["menu"] = irr::KEY_MENU;
	keys["pause"] = irr::KEY_PAUSE;
	keys["capital"] = irr::KEY_CAPITAL;
	keys["escape"] = irr::KEY_ESCAPE;
	keys["space"] = irr::KEY_SPACE;
	keys["prior"] = irr::KEY_PRIOR;
	keys["next"] = irr::KEY_NEXT;
	keys["end"] = irr::KEY_END;
	keys["home"] = irr::KEY_HOME;
	keys["left"] = irr::KEY_LEFT;
	keys["up"] = irr::KEY_UP;
	keys["right"] = irr::KEY_RIGHT;
	keys["down"] = irr::KEY_DOWN;
	keys["select"] = irr::KEY_SELECT;
	keys["print"] = irr::KEY_PRINT;
	keys["execut"] = irr::KEY_EXECUT;
	keys["snapshot"] = irr::KEY_SNAPSHOT;
	keys["insert"] = irr::KEY_INSERT;
	keys["delete"] = irr::KEY_DELETE;
	keys["help"] = irr::KEY_HELP;
	keys["0"] = irr::KEY_KEY_0;
	keys["1"] = irr::KEY_KEY_1;
	keys["2"] = irr::KEY_KEY_2;
	keys["3"] = irr::KEY_KEY_3;
	keys["4"] = irr::KEY_KEY_4;
	keys["5"] = irr::KEY_KEY_5;
	keys["6"] = irr::KEY_KEY_6;
	keys["7"] = irr::KEY_KEY_7;
	keys["8"] = irr::KEY_KEY_8;
	keys["9"] = irr::KEY_KEY_9;
	keys["A"] = irr::KEY_KEY_A;
	keys["B"] = irr::KEY_KEY_B;
	keys["C"] = irr::KEY_KEY_C;
	keys["D"] = irr::KEY_KEY_D;
	keys["E"] = irr::KEY_KEY_E;
	keys["F"] = irr::KEY_KEY_F;
	keys["G"] = irr::KEY_KEY_G;
	keys["H"] = irr::KEY_KEY_H;
	keys["I"] = irr::KEY_KEY_I;
	keys["J"] = irr::KEY_KEY_J;
	keys["K"] = irr::KEY_KEY_K;
	keys["L"] = irr::KEY_KEY_L;
	keys["M"] = irr::KEY_KEY_M;
	keys["N"] = irr::KEY_KEY_N;
	keys["O"] = irr::KEY_KEY_O;
	keys["P"] = irr::KEY_KEY_P;
	keys["Q"] = irr::KEY_KEY_Q;
	keys["R"] = irr::KEY_KEY_R;
	keys["S"] = irr::KEY_KEY_S;
	keys["T"] = irr::KEY_KEY_T;
	keys["U"] = irr::KEY_KEY_U;
	keys["V"] = irr::KEY_KEY_V;
	keys["W"] = irr::KEY_KEY_W;
	keys["X"] = irr::KEY_KEY_X;
	keys["Y"] = irr::KEY_KEY_Y;
	keys["Z"] = irr::KEY_KEY_Z;
	keys["numpad0"] = irr::KEY_NUMPAD0;
	keys["numpad1"] = irr::KEY_NUMPAD1;
	keys["numpad2"] = irr::KEY_NUMPAD2;
	keys["numpad3"] = irr::KEY_NUMPAD3;
	keys["numpad4"] = irr::KEY_NUMPAD4;
	keys["numpad5"] = irr::KEY_NUMPAD5;
	keys["numpad6"] = irr::KEY_NUMPAD6;
	keys["numpad7"] = irr::KEY_NUMPAD7;
	keys["numpad8"] = irr::KEY_NUMPAD8;
	keys["numpad9"] = irr::KEY_NUMPAD9;
	keys["multiply"] = irr::KEY_MULTIPLY;
	keys["add"] = irr::KEY_ADD;
	keys["separator"] = irr::KEY_SEPARATOR;
	keys["subtract"] = irr::KEY_SUBTRACT;
	keys["decimal"] = irr::KEY_DECIMAL;
	keys["divide"] = irr::KEY_DIVIDE;
	keys["f1"] = irr::KEY_F1;
	keys["f2"] = irr::KEY_F2;
	keys["f3"] = irr::KEY_F3;
	keys["f4"] = irr::KEY_F4;
	keys["f5"] = irr::KEY_F5;
	keys["f6"] = irr::KEY_F6;
	keys["f7"] = irr::KEY_F7;
	keys["f8"] = irr::KEY_F8;
	keys["f9"] = irr::KEY_F9;
	keys["f10"] = irr::KEY_F10;
	keys["f11"] = irr::KEY_F11;
	keys["f12"] = irr::KEY_F12;
	keys["f13"] = irr::KEY_F13;
	keys["f14"] = irr::KEY_F14;
	keys["f15"] = irr::KEY_F15;
	keys["f16"] = irr::KEY_F16;
	keys["f17"] = irr::KEY_F17;
	keys["f18"] = irr::KEY_F18;
	keys["f19"] = irr::KEY_F19;
	keys["f20"] = irr::KEY_F20;
	keys["f21"] = irr::KEY_F21;
	keys["f22"] = irr::KEY_F22;
	keys["f23"] = irr::KEY_F23;
	keys["f24"] = irr::KEY_F24;
	keys["numLock"] = irr::KEY_NUMLOCK;
	keys["scroll"] = irr::KEY_SCROLL;
	keys["lShift"] = irr::KEY_LSHIFT;
	keys["rShift"] = irr::KEY_RSHIFT;
	keys["lControl"] = irr::KEY_LCONTROL;
	keys["rControl"] = irr::KEY_RCONTROL;
	keys["lMenu"] = irr::KEY_LMENU;
	keys["rMenu"] = irr::KEY_RMENU;
	keys["plus"] = irr::KEY_PLUS;
	keys["comma"] = irr::KEY_COMMA;
	keys["minus"] = irr::KEY_MINUS;
	keys["period"] = irr::KEY_PERIOD;

	keysFromIrr[irr::KEY_CANCEL] = "cancel";
	keysFromIrr[irr::KEY_BACK] = "back";
	keysFromIrr[irr::KEY_TAB] = "tab";
	keysFromIrr[irr::KEY_CLEAR] = "clear";
	keysFromIrr[irr::KEY_RETURN] = "return";
	keysFromIrr[irr::KEY_SHIFT] = "shift";
	keysFromIrr[irr::KEY_CONTROL] = "control";
	keysFromIrr[irr::KEY_MENU] = "menu";
	keysFromIrr[irr::KEY_PAUSE] = "pause";
	keysFromIrr[irr::KEY_CAPITAL] = "capital";
	keysFromIrr[irr::KEY_ESCAPE] = "escape";
	keysFromIrr[irr::KEY_SPACE] = "space";
	keysFromIrr[irr::KEY_PRIOR] = "prior";
	keysFromIrr[irr::KEY_NEXT] = "next";
	keysFromIrr[irr::KEY_END] = "end";
	keysFromIrr[irr::KEY_HOME] = "home";
	keysFromIrr[irr::KEY_LEFT] = "left";
	keysFromIrr[irr::KEY_UP] = "up";
	keysFromIrr[irr::KEY_RIGHT] = "right";
	keysFromIrr[irr::KEY_DOWN] = "down";
	keysFromIrr[irr::KEY_SELECT] = "select";
	keysFromIrr[irr::KEY_PRINT] = "print";
	keysFromIrr[irr::KEY_EXECUT] = "execut";
	keysFromIrr[irr::KEY_SNAPSHOT] = "snapshot";
	keysFromIrr[irr::KEY_INSERT] = "insert";
	keysFromIrr[irr::KEY_DELETE] = "delete";
	keysFromIrr[irr::KEY_HELP] = "help";
	keysFromIrr[irr::KEY_KEY_0] = "0";
	keysFromIrr[irr::KEY_KEY_1] = "1";
	keysFromIrr[irr::KEY_KEY_2] = "2";
	keysFromIrr[irr::KEY_KEY_3] = "3";
	keysFromIrr[irr::KEY_KEY_4] = "4";
	keysFromIrr[irr::KEY_KEY_5] = "5";
	keysFromIrr[irr::KEY_KEY_6] = "6";
	keysFromIrr[irr::KEY_KEY_7] = "7";
	keysFromIrr[irr::KEY_KEY_8] = "8";
	keysFromIrr[irr::KEY_KEY_9] = "9";
	keysFromIrr[irr::KEY_KEY_A] = "A";
	keysFromIrr[irr::KEY_KEY_B] = "B";
	keysFromIrr[irr::KEY_KEY_C] = "C";
	keysFromIrr[irr::KEY_KEY_D] = "D";
	keysFromIrr[irr::KEY_KEY_E] = "E";
	keysFromIrr[irr::KEY_KEY_F] = "F";
	keysFromIrr[irr::KEY_KEY_G] = "G";
	keysFromIrr[irr::KEY_KEY_H] = "H";
	keysFromIrr[irr::KEY_KEY_I] = "I";
	keysFromIrr[irr::KEY_KEY_J] = "J";
	keysFromIrr[irr::KEY_KEY_K] = "K";
	keysFromIrr[irr::KEY_KEY_L] = "L";
	keysFromIrr[irr::KEY_KEY_M] = "M";
	keysFromIrr[irr::KEY_KEY_N] = "N";
	keysFromIrr[irr::KEY_KEY_O] = "O";
	keysFromIrr[irr::KEY_KEY_P] = "P";
	keysFromIrr[irr::KEY_KEY_Q] = "Q";
	keysFromIrr[irr::KEY_KEY_R] = "R";
	keysFromIrr[irr::KEY_KEY_S] = "S";
	keysFromIrr[irr::KEY_KEY_T] = "T";
	keysFromIrr[irr::KEY_KEY_U] = "U";
	keysFromIrr[irr::KEY_KEY_V] = "V";
	keysFromIrr[irr::KEY_KEY_W] = "W";
	keysFromIrr[irr::KEY_KEY_X] = "X";
	keysFromIrr[irr::KEY_KEY_Y] = "Y";
	keysFromIrr[irr::KEY_KEY_Z] = "Z";
	keysFromIrr[irr::KEY_NUMPAD0] = "numpad0";
	keysFromIrr[irr::KEY_NUMPAD1] = "numpad1";
	keysFromIrr[irr::KEY_NUMPAD2] = "numpad2";
	keysFromIrr[irr::KEY_NUMPAD3] = "numpad3";
	keysFromIrr[irr::KEY_NUMPAD4] = "numpad4";
	keysFromIrr[irr::KEY_NUMPAD5] = "numpad5";
	keysFromIrr[irr::KEY_NUMPAD6] = "numpad6";
	keysFromIrr[irr::KEY_NUMPAD7] = "numpad7";
	keysFromIrr[irr::KEY_NUMPAD8] = "numpad8";
	keysFromIrr[irr::KEY_NUMPAD9] = "numpad9";
	keysFromIrr[irr::KEY_MULTIPLY] = "multiply";
	keysFromIrr[irr::KEY_ADD] = "add";
	keysFromIrr[irr::KEY_SEPARATOR] = "separator";
	keysFromIrr[irr::KEY_SUBTRACT] = "subtract";
	keysFromIrr[irr::KEY_DECIMAL] = "decimal";
	keysFromIrr[irr::KEY_DIVIDE] = "divide";
	keysFromIrr[irr::KEY_F1] = "f1";
	keysFromIrr[irr::KEY_F2] = "f2";
	keysFromIrr[irr::KEY_F3] = "f3";
	keysFromIrr[irr::KEY_F4] = "f4";
	keysFromIrr[irr::KEY_F5] = "f5";
	keysFromIrr[irr::KEY_F6] = "f6";
	keysFromIrr[irr::KEY_F7] = "f7";
	keysFromIrr[irr::KEY_F8] = "f8";
	keysFromIrr[irr::KEY_F9] = "f9";
	keysFromIrr[irr::KEY_F10] = "f10";
	keysFromIrr[irr::KEY_F11] = "f11";
	keysFromIrr[irr::KEY_F12] = "f12";
	keysFromIrr[irr::KEY_F13] = "f13";
	keysFromIrr[irr::KEY_F14] = "f14";
	keysFromIrr[irr::KEY_F15] = "f15";
	keysFromIrr[irr::KEY_F16] = "f16";
	keysFromIrr[irr::KEY_F17] = "f17";
	keysFromIrr[irr::KEY_F18] = "f18";
	keysFromIrr[irr::KEY_F19] = "f19";
	keysFromIrr[irr::KEY_F20] = "f20";
	keysFromIrr[irr::KEY_F21] = "f21";
	keysFromIrr[irr::KEY_F22] = "f22";
	keysFromIrr[irr::KEY_F23] = "f23";
	keysFromIrr[irr::KEY_F24] = "f24";
	keysFromIrr[irr::KEY_NUMLOCK] = "numlock";
	keysFromIrr[irr::KEY_SCROLL] = "scroll";
	keysFromIrr[irr::KEY_LSHIFT] = "lShift";
	keysFromIrr[irr::KEY_RSHIFT] = "rShift";
	keysFromIrr[irr::KEY_LCONTROL] = "lControl";
	keysFromIrr[irr::KEY_RCONTROL] = "rControl";
	keysFromIrr[irr::KEY_LMENU] = "lMenu";
	keysFromIrr[irr::KEY_RMENU] = "rMenu";
	keysFromIrr[irr::KEY_PLUS] = "plus";
	keysFromIrr[irr::KEY_COMMA] = "comma";
	keysFromIrr[irr::KEY_MINUS] = "minus";
	keysFromIrr[irr::KEY_PERIOD] = "period";
}

irr::EKEY_CODE InputConvertor::getKey(const std::string &key)
{
	if (keys.count(key) != 0)
		return keys[key];
	return irr::KEY_OEM_CLEAR;
}

const std::string &InputConvertor::getKey(int key)
{
	if (keysFromIrr.count(key) != 0)
		return keysFromIrr[key];
	return keysFromIrr[irr::KEY_OEM_CLEAR];
}
